package com.StudentServices.MarksService.controller;

import com.StudentServices.MarksService.exception.ResourceNotFoundException;
import com.StudentServices.MarksService.model.StudentMarks;
import com.StudentServices.MarksService.service.StudentService;
import org.springframework.beans.factory.annotation.Autowired;

import org.springframework.boot.context.config.ConfigDataResourceNotFoundException;

import org.springframework.http.HttpStatus;

import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@CrossOrigin(origins = "*")
@RestController
@RequestMapping("/api/")

public class StudentMarksController {

    @Autowired StudentService studentService;

    // (GET) findall studentmarks
    @GetMapping("/studentMarks")
    ResponseEntity<List<StudentMarks>> findAllStudentMarks(){
        return ResponseEntity.ok(studentService.findAllStudents());
    }
    // (POST) create studentmark
    @PostMapping("/studentMarks")
    public ResponseEntity<StudentMarks> createMarks(@RequestBody StudentMarks studentMarks) {
        return ResponseEntity.ok(studentService.addStudent(studentMarks));
    }

    // (GET) find studentmark by id
    @GetMapping("/studentMarks/{id}")
    ResponseEntity<StudentMarks> findStudentMarksById(@PathVariable String id) throws ResourceNotFoundException {

        StudentMarks sm = studentService.getStudentById(id).
                orElseThrow( () -> new ResourceNotFoundException("Student Marks not found... " + id));
        return ResponseEntity.ok(sm);
    }


//
//    // Get a particular employee
//    // GET: http://localhost:8080/api/v1/employees/__num__
//    @GetMapping("/employees/{id}")
//    public ResponseEntity<Employee> getEmployeeById(@PathVariable(value = "id") Long employeeId) throws ResourceNotFoundException {
//        Employee employee = employeeService.getEmployeeById(employeeId)
//                .orElseThrow(() -> new ResourceNotFoundException("Employee by Id Not Found" + employeeId));
//        return ResponseEntity.ok().body(employee);
//    }
//
//    // Update a particular employee
//    @PutMapping("/employees/update/")
//    public ResponseEntity<Employee> updateEmployeeById(@RequestBody Employee employeeNew) throws ResourceNotFoundException {
//        Employee employee = employeeService.getEmployeeById(employeeNew.getId())
//                .orElseThrow(() -> new ResourceNotFoundException("Employee by Id Not Found" + employeeNew.getId()));
//
//        employee.setLastName(employeeNew.getLastName());
//        employee.setFirstName(employeeNew.getFirstName());
//
//        employeeService.updateEmployee(employee);
//
//        return ResponseEntity.ok().body(employee);
//    }



    @PutMapping("/studentMarks/update/{emailAddress}")
    public ResponseEntity<StudentMarks> updateStudentMarks(@PathVariable (value= "emailAddress") String emailAddressId) throws ResourceNotFoundException {
        StudentMarks studentMarks = studentService.getStudentById(emailAddressId)
                .orElseThrow(() -> new ResourceNotFoundException("Employee not found for this id :: " + emailAddressId));

        final StudentMarks updatedStudentMarks = studentService.editStudentMarks(studentMarks);
        return ResponseEntity.ok(updatedStudentMarks);
    }



}
